Index: trunk/src/world_entities/weapons/weapon.cc
===================================================================
--- trunk/src/world_entities/weapons/weapon.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/weapon.cc	(revision 9869)
@@ -21,9 +21,7 @@
 #include "weapon.h"
 
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 #include "world_entities/projectiles/projectile.h"
 
-#include "util/loading/resource_manager.h"
-#include "class_list.h"
 #include "util/loading/factory.h"
 #include "util/loading/load_param.h"
@@ -33,8 +31,9 @@
 #include "sound_source.h"
 #include "sound_buffer.h"
+#include "resource_sound_buffer.h"
 
 #include "elements/glgui_energywidget.h"
 
-
+ObjectListDefinition(Weapon);
 
 ////////////////////
@@ -58,11 +57,8 @@
 {
   for (int i = 0; i < WS_STATE_COUNT; i++)
-    if (this->animation[i] && ClassList::exists(animation[i], CL_ANIMATION))  //!< @todo this should check animation3D
+    if (this->animation[i] && Animation::objectList().exists(animation[i]))  //!< @todo this should check animation3D
       delete this->animation[i];
-  for (int i = 0; i < WA_ACTION_COUNT; i++)
-    if (this->soundBuffers[i] != NULL && ClassList::exists(this->soundBuffers[i], CL_SOUND_BUFFER))
-      ResourceManager::getInstance()->unload(this->soundBuffers[i]);
-
-  if (ClassList::exists(this->soundSource, CL_SOUND_SOURCE))
+
+  if (OrxSound::SoundSource::objectList().exists(this->soundSource))
     delete this->soundSource;
 }
@@ -73,10 +69,10 @@
  * @returns the newly created Weapon.
  */
-Weapon* Weapon::createWeapon(ClassID weaponID)
+Weapon* Weapon::createWeapon(const ClassID& weaponID)
 {
   BaseObject* createdObject = Factory::fabricate(weaponID);
   if (createdObject != NULL)
   {
-    if (createdObject->isA(CL_WEAPON))
+    if (createdObject->isA(Weapon::staticClassID()))
       return dynamic_cast<Weapon*>(createdObject);
     else
@@ -89,4 +85,21 @@
 }
 
+Weapon* Weapon::createWeapon(const std::string& weaponName)
+{
+  BaseObject* createdObject = Factory::fabricate(weaponName);
+  if (createdObject != NULL)
+  {
+    if (createdObject->isA(Weapon::staticClassID()))
+      return dynamic_cast<Weapon*>(createdObject);
+    else
+    {
+      delete createdObject;
+      return NULL;
+    }
+  }
+  return NULL;
+}
+
+
 /**
  * initializes the Weapon with ALL default values
@@ -96,5 +109,5 @@
 void Weapon::init()
 {
-  this->setClassID(CL_WEAPON, "Weapon");
+  this->registerObject(this, Weapon::_objectList);
   this->currentState     = WS_INACTIVE;            //< Normaly the Weapon is Inactive
   this->requestedAction  = WA_NONE;                //< No action is requested by default
@@ -105,6 +118,4 @@
     this->animation[i] = NULL;                   //< No animation
   }
-  for (int i = 0; i < WA_ACTION_COUNT; i++)
-    this->soundBuffers[i] = NULL;                  //< No Sounds
 
   this->soundSource = new OrxSound::SoundSource(this);       //< Every Weapon has exacty one SoundSource.
@@ -115,5 +126,5 @@
   this->defaultTarget = NULL;                      //< Nothing is Targeted by default.
 
-  this->projectile = CL_NULL;                      //< No Projectile Class is Connected to this weapon
+  this->projectile = NullClass::staticClassID();         //< No Projectile Class is Connected to this weapon
   this->projectileFactory = NULL;                  //< No Factory generating Projectiles is selected.
 
@@ -163,8 +174,6 @@
  * What it does, is telling the Weapon what Projectiles it can Emit.
  */
-void Weapon::setProjectileType(ClassID projectile)
-{
-  if (projectile == CL_NULL)
-    return;
+void Weapon::setProjectileType(const ClassID& projectile)
+{
   this->projectile = projectile;
   this->projectileFactory = FastFactory::searchFastFactory(projectile);
@@ -259,11 +268,9 @@
   if (action >= WA_ACTION_COUNT)
     return;
-  if (this->soundBuffers[action] != NULL)
-    ResourceManager::getInstance()->unload(this->soundBuffers[action]);
 
   else if (!soundFile.empty())
   {
-    this->soundBuffers[action] = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load(soundFile, WAV);
-    if (this->soundBuffers[action] != NULL)
+    this->soundBuffers[action] = OrxSound::ResourceSoundBuffer(soundFile);
+    if (this->soundBuffers[action].loaded())
     {
       PRINTF(4)("Loaded sound %s to action %s.\n", soundFile.c_str(), actionToChar(action));
@@ -275,5 +282,5 @@
   }
   else
-    this->soundBuffers[action] = NULL;
+    this->soundBuffers[action] = OrxSound::SoundBuffer();
 }
 
@@ -409,21 +416,21 @@
   {
     case WA_SHOOT:
-      return this->fireW();
-      break;
+    return this->fireW();
+    break;
     case WA_CHARGE:
-      return this->chargeW();
-      break;
+    return this->chargeW();
+    break;
     case WA_RELOAD:
-      return this->reloadW();
-      break;
+    return this->reloadW();
+    break;
     case WA_DEACTIVATE:
-      return this->deactivateW();
-      break;
+    return this->deactivateW();
+    break;
     case WA_ACTIVATE:
-      return this->activateW();
-      break;
+    return this->activateW();
+    break;
     default:
-      PRINTF(2)("Action %s Not Implemented yet \n", Weapon::actionToChar(action));
-      return false;
+    PRINTF(2)("Action %s Not Implemented yet \n", Weapon::actionToChar(action));
+    return false;
   }
 }
@@ -438,5 +445,5 @@
   {
     // play Sound
-    if (likely(this->soundBuffers[WA_ACTIVATE] != NULL))
+    if (likely(this->soundBuffers[WA_ACTIVATE].loaded()))
       this->soundSource->play(this->soundBuffers[WA_ACTIVATE]);
     this->updateWidgets();
@@ -460,5 +467,5 @@
     PRINTF(4)("Deactivating the Weapon %s\n", this->getCName());
     // play Sound
-    if (this->soundBuffers[WA_DEACTIVATE] != NULL)
+    if (this->soundBuffers[WA_DEACTIVATE].loaded())
       this->soundSource->play(this->soundBuffers[WA_DEACTIVATE]);
     // deactivate
@@ -479,5 +486,5 @@
   {
     // playing Sound
-    if (this->soundBuffers[WA_CHARGE] != NULL)
+    if (this->soundBuffers[WA_CHARGE].loaded())
       this->soundSource->play(this->soundBuffers[WA_CHARGE]);
 
@@ -504,5 +511,5 @@
   {
     // playing Sound
-    if (this->soundBuffers[WA_SHOOT] != NULL)
+    if (this->soundBuffers[WA_SHOOT].loaded())
       this->soundSource->play(this->soundBuffers[WA_SHOOT]);
     this->updateWidgets();
@@ -528,5 +535,5 @@
 {
   PRINTF(4)("Reloading Weapon %s\n", this->getCName());
-  if (this->ammoContainer.get() != NULL &&
+  if (!this->ammoContainer.isNull() &&
       unlikely(this->energy + this->ammoContainer->getStoredEnergy() < this->minCharge))
   {
@@ -537,8 +544,8 @@
 
 
-  if (this->soundBuffers[WA_RELOAD] != NULL)
+  if (this->soundBuffers[WA_RELOAD].loaded())
     this->soundSource->play(this->soundBuffers[WA_RELOAD]);
 
-  if (this->ammoContainer.get() != NULL)
+  if (!this->ammoContainer.isNull())
     this->ammoContainer->fillWeapon(this);
   else
@@ -680,24 +687,24 @@
   {
     case WA_SHOOT:
-      return "shoot";
-      break;
+    return "shoot";
+    break;
     case WA_CHARGE:
-      return "charge";
-      break;
+    return "charge";
+    break;
     case WA_RELOAD:
-      return "reload";
-      break;
+    return "reload";
+    break;
     case WA_ACTIVATE:
-      return "activate";
-      break;
+    return "activate";
+    break;
     case WA_DEACTIVATE:
-      return "deactivate";
-      break;
+    return "deactivate";
+    break;
     case WA_SPECIAL1:
-      return "special1";
-      break;
+    return "special1";
+    break;
     default:
-      return "none";
-      break;
+    return "none";
+    break;
   }
 }
@@ -743,27 +750,27 @@
   {
     case WS_SHOOTING:
-      return "shooting";
-      break;
+    return "shooting";
+    break;
     case WS_CHARGING:
-      return "charging";
-      break;
+    return "charging";
+    break;
     case WS_RELOADING:
-      return "reloading";
-      break;
+    return "reloading";
+    break;
     case WS_ACTIVATING:
-      return "activating";
-      break;
+    return "activating";
+    break;
     case WS_DEACTIVATING:
-      return "deactivating";
-      break;
+    return "deactivating";
+    break;
     case WS_IDLE:
-      return "idle";
-      break;
+    return "idle";
+    break;
     case WS_INACTIVE:
-      return "inactive";
-      break;
+    return "inactive";
+    break;
     default:
-      return "none";
-      break;
-  }
-}
+    return "none";
+    break;
+  }
+}
Index: trunk/src/world_entities/weapons/weapon.h
===================================================================
--- trunk/src/world_entities/weapons/weapon.h	(revision 9656)
+++ trunk/src/world_entities/weapons/weapon.h	(revision 9869)
@@ -19,4 +19,6 @@
 #include "ammo_container.h"
 
+#include "sound_buffer.h"
+
 // FORWARD DECLARATION
 class Projectile;
@@ -83,9 +85,12 @@
 class Weapon : public WorldEntity
 {
+  ObjectListDeclaration(Weapon);
+
   public:
     // INITIALISATION //
     Weapon ();
     virtual ~Weapon ();
-    static Weapon* createWeapon(ClassID weaponID);
+    static Weapon* createWeapon(const ClassID& weaponID);
+    static Weapon* createWeapon(const std::string& weaponName);
 
     void init();
@@ -110,5 +115,5 @@
     /** @returns the Capabilities of this Weapon */
     inline long getCapability() const { return this->capability; };
-    void setProjectileType(ClassID projectile);
+    void setProjectileType(const ClassID& projectile);
     void setProjectileTypeC(const std::string& projectile);
     /** @returns The projectile's classID */
@@ -216,12 +221,12 @@
     // PHASES //
     ////////////
-    OrxSound::SoundSource* soundSource;                      //!< A SoundSource to play sound from (this is connected to the PNode of the Weapon)
-
-    WeaponState            currentState;                     //!< The State the weapon is in.
-    WeaponAction           requestedAction;                  //!< An action to try to Engage after the currentState ends.
-    float                  stateDuration;                    //!< how long the state has taken until now.
-    float                  times[WS_STATE_COUNT];            //!< Times to stay in the different States @see WeaponState.
-    Animation3D*           animation[WS_STATE_COUNT];        //!< Animations for all the States (you can say yourself on what part of the gun this animation acts).
-    OrxSound::SoundBuffer* soundBuffers[WA_ACTION_COUNT];    //!< SoundBuffers for all actions @see WeaponAction.
+    OrxSound::SoundSource* soundSource;                     //!< A SoundSource to play sound from (this is connected to the PNode of the Weapon)
+
+    WeaponState            currentState;                    //!< The State the weapon is in.
+    WeaponAction           requestedAction;                 //!< An action to try to Engage after the currentState ends.
+    float                  stateDuration;                   //!< how long the state has taken until now.
+    float                  times[WS_STATE_COUNT];           //!< Times to stay in the different States @see WeaponState.
+    Animation3D*           animation[WS_STATE_COUNT];       //!< Animations for all the States (you can say yourself on what part of the gun this animation acts).
+    OrxSound::SoundBuffer  soundBuffers[WA_ACTION_COUNT];   //!< SoundBuffers for all actions @see WeaponAction.
 
     PNode                  emissionPoint;                   //!< The point, where the projectiles are emitted. (this is coppled with the Weapon by default)
Index: trunk/src/world_entities/weapons/weapon_manager.cc
===================================================================
--- trunk/src/world_entities/weapons/weapon_manager.cc	(revision 9656)
+++ trunk/src/world_entities/weapons/weapon_manager.cc	(revision 9869)
@@ -17,14 +17,13 @@
 */
 
-#define DEBUG_SPECIAL_MODULE 4 //DEBUG_MODULE_WEAPON
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WEAPON
 
 #include "weapon_manager.h"
 #include "weapon.h"
 #include "crosshair.h"
-#include "class_list.h"
 
 #include "playable.h"
 
-#include "util/loading/load_param.h"
+#include "util/loading/load_param_xml.h"
 #include "util/loading/factory.h"
 
@@ -32,4 +31,5 @@
 
 
+ObjectListDefinition(WeaponManager);
 /**
  * @brief this initializes the weaponManager for a given nnumber of weapon slots
@@ -57,6 +57,6 @@
   // crosshair being a PNode it must not be deleted (this is because PNodes delete themselves.)
   // rennerc: crosshair seems not to delete itselve
-  if (ClassList::exists(this->crosshair, CL_CROSSHAIR))
-    delete this->crosshair;
+  //if (Crosshair::objectList().exists(this->crosshair))
+  //  delete this->crosshair;
 }
 
@@ -66,5 +66,5 @@
 void WeaponManager::init()
 {
-  this->setClassID(CL_WEAPON_MANAGER, "WeaponManager");
+  this->registerObject(this, WeaponManager::_objectList);
 
   this->parentNode = NULL;
@@ -298,9 +298,9 @@
   {
     this->parentNode->addChild(weapon);
-    if (this->parentEntity->isA(CL_PLAYABLE))
+    if (this->parentEntity->isA(Playable::staticClassID()))
       dynamic_cast<Playable*>(this->parentEntity)->weaponConfigChanged();
     weapon->setDefaultTarget(this->crosshair);
   }
-  PRINTF(3)("Added a new Weapon (%s::%s) to the WeaponManager: config %i/ slot %i\n", weapon->getClassCName(), weapon->getCName(), configID, slotID);
+  PRINTF(4)("Added a new Weapon (%s::%s) to the WeaponManager: config %i/ slot %i\n", weapon->getClassCName(), weapon->getCName(), configID, slotID);
   return true;
 }
@@ -311,5 +311,5 @@
  * @param ammo the ammo to increase
  */
-float WeaponManager::increaseAmmunition(ClassID projectileType, float ammo)
+float WeaponManager::increaseAmmunition(const ClassID& projectileType, float ammo)
 {
   return this->getAmmoContainer(projectileType)->increaseEnergy(ammo);
@@ -324,5 +324,5 @@
 {
   assert (weapon != NULL);
-  return this->increaseAmmunition(weapon->getLeafClassID(), ammo);
+  return this->increaseAmmunition(weapon->getClassID(), ammo);
 
 }
@@ -468,5 +468,5 @@
       else
         this->currentSlotConfig[i].position.deactivateNode();
-      if (this->parentEntity != NULL && this->parentEntity->isA(CL_PLAYABLE))
+      if (this->parentEntity != NULL && this->parentEntity->isA(Playable::staticClassID()))
         dynamic_cast<Playable*>(this->parentEntity)->weaponConfigChanged();
     }
@@ -523,5 +523,5 @@
 }
 
-CountPointer<AmmoContainer>& WeaponManager::getAmmoContainer(ClassID projectileType)
+CountPointer<AmmoContainer>& WeaponManager::getAmmoContainer(const ClassID& projectileType)
 {
   for (unsigned int i = 0; i < this->ammo.size(); i++)
@@ -537,5 +537,5 @@
 {
   assert (weapon != NULL);
-  return (this->getAmmoContainer(weapon->getLeafClassID()));
+  return (this->getAmmoContainer(weapon->getClassID()));
 }
 
Index: trunk/src/world_entities/weapons/weapon_manager.h
===================================================================
--- trunk/src/world_entities/weapons/weapon_manager.h	(revision 9656)
+++ trunk/src/world_entities/weapons/weapon_manager.h	(revision 9869)
@@ -39,4 +39,5 @@
  */
 class WeaponManager : public BaseObject {
+  ObjectListDeclaration(WeaponManager);
 
   //! an enumerator defining a Slot, where a Weapon can be stored inside.
@@ -89,5 +90,5 @@
     void changeWeaponConfig(int weaponConfig);
 
-    float increaseAmmunition(ClassID projectileType, float ammo);
+    float increaseAmmunition(const ClassID& projectileType, float ammo);
     float inclreaseAmmunition(const Weapon* weapon, float ammo);
 
@@ -106,5 +107,5 @@
  // private:
     int getNextFreeSlot(int configID, long capability = WTYPE_ALL);
-    CountPointer<AmmoContainer>& getAmmoContainer(ClassID projectileType);
+    CountPointer<AmmoContainer>& getAmmoContainer(const ClassID& projectileType);
     CountPointer<AmmoContainer>& getAmmoContainer(const Weapon* weapon);
 
Index: trunk/src/world_entities/weather_effects/atmospheric_engine.cc
===================================================================
--- trunk/src/world_entities/weather_effects/atmospheric_engine.cc	(revision 9869)
+++ trunk/src/world_entities/weather_effects/atmospheric_engine.cc	(revision 9869)
@@ -0,0 +1,112 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Andreas Maechler, David Hasenfratz
+   co-programmer: ...
+*/
+
+#include "atmospheric_engine.h"
+
+#include "weather_effects/fog_effect.h"
+
+#include "util/loading/load_param_xml.h"
+#include "util/loading/factory.h"
+
+ObjectListDefinition(AtmosphericEngine);
+
+/**
+ * @param root The XML-element to load the AtmosphericEngine from
+ */
+AtmosphericEngine::AtmosphericEngine()
+{
+  this->registerObject(this, AtmosphericEngine::_objectList);
+}
+
+/**
+ *  The Pointer to this AtmosphericEngine
+*/
+AtmosphericEngine* AtmosphericEngine::singletonRef = NULL;
+
+
+/**
+ *  destroys a AtmosphericEngine
+ */
+AtmosphericEngine::~AtmosphericEngine()
+{
+  AtmosphericEngine::singletonRef = NULL;
+
+  while(!WeatherEffect::objectList().empty())
+    delete WeatherEffect::objectList().front();
+}
+
+/**
+ * @param root The XML-element to load the AtmosphericEngine from
+ */
+void AtmosphericEngine::loadParams(const TiXmlElement* root)
+{
+  LoadParamXML(root, "WeatherEffect", this, AtmosphericEngine, loadWeatherEffect);
+  LoadParamXML(root, "SunEffect", this, AtmosphericEngine, loadSunEffect);
+}
+
+/**
+ * @param root The XML-element to load WeatherEffects from
+ */
+void AtmosphericEngine::loadWeatherEffect(const TiXmlElement* root)
+{
+  LOAD_PARAM_START_CYCLE(root, element);
+  {
+    PRINTF(4)("element is: %s\n", element->Value());
+    // Factory::fabricate(element);
+
+    BaseObject* bo = Factory::fabricate(element);
+    if( bo == NULL)
+      PRINTF(0)(" Could not create Element %s\n", element->Value());
+  }
+  LOAD_PARAM_END_CYCLE(element);
+}
+
+/**
+ * @param root The XML-element to load SunEffects from
+ */
+void AtmosphericEngine::loadSunEffect(const TiXmlElement* root)
+{
+  LOAD_PARAM_START_CYCLE(root, element);
+  {
+    PRINTF(4)("element is: %s\n", element->Value());
+  }
+  LOAD_PARAM_END_CYCLE(element);
+}
+
+
+/**
+ * draws the effect, if needed
+ */
+void AtmosphericEngine::draw() const
+{
+  for (ObjectList<WeatherEffect>::const_iterator it = WeatherEffect::objectList().begin();
+       it != WeatherEffect::objectList().end();
+       ++it)
+    (*it)->draw();
+}
+
+
+
+/**
+ * ticks the effect if there is any time dependancy
+ */
+void AtmosphericEngine::tick(float dt)
+{
+
+  for (ObjectList<WeatherEffect>::const_iterator it = WeatherEffect::objectList().begin();
+       it != WeatherEffect::objectList().end();
+       ++it)
+    (*it)->tick(dt);
+}
Index: trunk/src/world_entities/weather_effects/atmospheric_engine.h
===================================================================
--- trunk/src/world_entities/weather_effects/atmospheric_engine.h	(revision 9869)
+++ trunk/src/world_entities/weather_effects/atmospheric_engine.h	(revision 9869)
@@ -0,0 +1,43 @@
+/*!
+ * @file atmospheric_engine.h
+ *
+ */
+
+#ifndef _ATMOSPHERIC_ENGINE_H
+#define _ATMOSPHERIC_ENGINE_H
+
+#include "base_object.h"
+
+
+class TiXmlElement;
+
+class AtmosphericEngine : public BaseObject
+{
+  ObjectListDeclaration(AtmosphericEngine);
+  public:
+    ~AtmosphericEngine();
+
+    /** @returns a Pointer to the only object of this Class */
+    inline static AtmosphericEngine* getInstance() { if (!AtmosphericEngine::singletonRef) AtmosphericEngine::singletonRef = new AtmosphericEngine();  return AtmosphericEngine::singletonRef; };
+
+    void loadParams(const TiXmlElement* root);
+
+    void init();
+
+    void draw() const;
+    void tick(float dt);
+
+    // inline bool isActivated() const { return this->bActivated; }
+
+    void loadWeatherEffect(const TiXmlElement* root);
+    void loadSunEffect(const TiXmlElement* root);
+
+  private:
+
+    AtmosphericEngine();
+
+    static AtmosphericEngine*     singletonRef;       //!< Pointer to the only instance of this Class
+};
+
+
+#endif /* _ATMOSPHERIC_ENGINE */
